#!/usr/bin/perl

# (c) Alexandr A Alexeev 2010, http://eax.me/
# rapidshare.ru - до 1.5 Гб

my $file = shift;
my $debug = shift;

unless($file) {
  print "Usage: $0 <file> [debug]\n";
  exit 1;
}

print "Downloading form...\n";

$data = `curl -L http://rapidshare.ru/ 2>&1`;

if($?) {
  print "Download failed!\n";
  exit 2;
}

unless(($action) = $data =~ qr{id=actionurl value="([^"]+)"}) {
  print "Form parsing failed!\n";
  exit 3;
}

# TODO: filter $action ...

print "Uploading file...\n";

$data = `curl -L -F "fl1=\@$file" -F "accepted=1" $action 2> /dev/null`;

if($?) {
  print "Upload failed!\n";
  exit 4;
}

unless(($url) = $data =~ qr{\[URL\]([^\[]+)\[/URL\]}) {
  if($debug) {
    chomp($dump = `pwgen -cn 9 1`);
    $dump .= ".html";
    open DUMP, ">$dump" or die "Failed to save dump to $dump\n";
    print DUMP $data;
    close DUMP;
  } else {
    $dump = "[none]";
  }
  print "Failed to parse result page, dump: $dump!\n";
  exit 5;
}

print "RESULT: $url\n";
